<?php

namespace SM\Controller;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00052001DescontoMaximoServicoOperadorService;
use SM\Traits\TResponse;

class Sm00052001DescontoMaximoServicoOperadorController 
{
    use TResponse;
    
    protected $descMaximoServicoService;
    
    public function __construct(Sm00052001DescontoMaximoServicoOperadorService $descMaximoServicoService) {
        $this->descMaximoServicoService = $descMaximoServicoService;
    }

    public function getNomeOperadorDescontoMaximoServicoOperador(Request $request, Response $response){
        try {
            $data = $this->descMaximoServicoService->getNomeOperadorDescontoMaximoServicoOperador();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getServicoDescontoMaximoServicoOperador(Request $request, Response $response){
        try {
            $data = $this->descMaximoServicoService->getServicoDescontoMaximoServicoOperador($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveDescMaxServicoOperador(DTO\Request $request, DTO\Response $response){
        try {
            $this->descMaximoServicoService->saveDescMaxServicoOperador($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteDescMaxServicoModalServico(DTO\Request $request, DTO\Response $response){
        try{
            $this->descMaximoServicoService->deleteDescMaxServicoModalServico($request->getParameters());
        }
        catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}