<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00050002QuantidadeMaximaParcelasPerfilAcessoFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getQuantidadeMaximaParcelasPerfilAcesso() {

        $sql = "SELECT QT.NRQTPARCMAXPERFACESS, QT.QTPARCMAXPERFACESS, QT.NRPERFILACESSO,OP.NMPERFILACESSO
                FROM FCT_QTPARCMAXPERFACESS QT
                INNER JOIN PERFILACESSO OP 
                ON QT.NRPERFILACESSO = OP.NRPERFILACESSO";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function validaQtdMaximaParcelasPerfilAcesso(array $params){

        $sql = "SELECT COUNT (*) AS QTD
        FROM FCT_QTPARCMAXPERFACESS
        WHERE NRPERFILACESSO = :NRPERFILACESSO
        AND NRQTPARCMAXPERFACESS <> NVL(:NRQTPARCMAXPERFACESS,-1)";

        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();

    }

    public function insertQtdMaximaParcelasPerfilAcesso (array $params){
        
        $sql = "INSERT INTO FCT_QTPARCMAXPERFACESS (
            NRQTPARCMAXPERFACESS,   NRPERFILACESSO,   QTPARCMAXPERFACESS,
            NRORG,                IDATIVO,      DTINCLUSAO,   
            NRORGINCLUSAO,        CDOPERINCLUSAO
        )
        VALUES (
            :NRQTPARCMAXPERFACESS,   :NRPERFILACESSO,   :QTPARCMAXPERFACESS,
            :NRORG,                :IDATIVO,       SYSDATE,    
            :NRORGINCLUSAO,        :CDOPERINCLUSAO
        )";

        $this->connection->executeStatement($sql, $params);
    }
    
    public function updateQtdMaximaParcelasPerfilAcesso($params){
        $sql = "UPDATE FCT_QTPARCMAXPERFACESS 
        SET NRPERFILACESSO = :NRPERFILACESSO, 
        QTPARCMAXPERFACESS = :QTPARCMAXPERFACESS,
        NRORG = :NRORG, 
        IDATIVO = :IDATIVO,
        NRORGINCLUSAO = :NRORGINCLUSAO,
        CDOPERINCLUSAO = : CDOPERINCLUSAO
        WHERE NRQTPARCMAXPERFACESS = :NRQTPARCMAXPERFACESS";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function deleteQtdMaximaParcelasPerfilAcesso($params){
        $sql = "DELETE FROM FCT_QTPARCMAXPERFACESS WHERE NRQTPARCMAXPERFACESS = :NRQTPARCMAXPERFACESS";
        $this->connection->executeStatement($sql, $params);
    }

}