<?php

namespace SM\Service;

use SM\Factory\Sm00050001QuantidadeMaximaParcelasOperadorFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class Sm00050001QuantidadeMaximaParcelasOperadorService {

    protected $connection;
    protected $qtdMaxParcelasFactory;
    protected $environment;
    protected $newCode;

    
    public function __construct(Sm00050001QuantidadeMaximaParcelasOperadorFactory $qtdMaxParcelasFactory, Environment $environment, NewCode $newCode, EntityManager $entityManager) {
        $this->qtdMaxParcelasFactory = $qtdMaxParcelasFactory;
        $this->environment                  = $environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();

    }

    public function getQuantidadeMaximaParcelasOperador(){
        return $this->qtdMaxParcelasFactory->getQuantidadeMaximaParcelasOperador();
    }

    public function saveQtdMaximaParcelasOperador($parametros){
        $cdoperador = $this->environment->getCdOperador();
        $nrorg = $this->environment->getNrOrg();
        $this->connection->beginTransaction();

        $paramsaux = array(
            "CDOPERADOR" => $parametros[0]['CDOPERADOR'],
            "NRQTPARCMAXIMAOPER" => $parametros[0]['NRQTPARCMAXIMAOPER']
        );

        $dados = $this->qtdMaxParcelasFactory->validaQtdMaximaParcelasOperador($paramsaux);

        try{
            foreach($parametros as $chave =>$parcelas){
                if($parcelas["NRQTPARCMAXIMAOPER"] == 0){    
                    $nrqtparcemaximaoper = $this->newCode->getCodeByTableName("FCT_QTPARCMAXIMAOPER", $nrorg, 1, 10, true);
                    $parametros = array(
                    "NRQTPARCMAXIMAOPER"     => $nrqtparcemaximaoper,
                    "CDOPERADOR"             => $parcelas['CDOPERADOR'],
                    "QTPARCMAXIMAOPER"       => $parcelas['QTPARCMAXIMAOPER'],
                    "NRORG"                  => $nrorg,
                    "IDATIVO"                => "S",
                    "NRORGINCLUSAO"          => $nrorg,
                    "CDOPERINCLUSAO"         => $cdoperador
                    );
                    if($dados[0]["QTD"] > 0){
                        throw new \Exception("EXISTE");
                    }else{
                        $this->qtdMaxParcelasFactory->insertQtdMaximaParcelasOperador($parametros);
                    }
                }else{
                    $parametros = array(
                    "NRQTPARCMAXIMAOPER"     => $parcelas['NRQTPARCMAXIMAOPER'],
                    "CDOPERADOR"             => $parcelas['CDOPERADOR'],
                    "QTPARCMAXIMAOPER"       => $parcelas['QTPARCMAXIMAOPER'],
                    "NRORG"                  => $nrorg,
                    "IDATIVO"                => "S",    
                    "NRORGINCLUSAO"          => $nrorg,
                    "CDOPERINCLUSAO"         => $cdoperador,
                    );
                    if($dados[0]["QTD"] > 0){
                        throw new \Exception("EXISTE");
                    }else{
                        $this->qtdMaxParcelasFactory->updateQtdMaximaParcelasOperador($parametros);;
                    }   
                }
            }
            $this->connection->commit();
        }catch(\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
    public function deleteQtdMaximaParcelasOperador($parametros) {
        $this->connection->beginTransaction();
        try{
            foreach($parametros as $chave => $parcelas){
                $dataParam = array( "NRQTPARCMAXIMAOPER" => $parcelas["NRQTPARCMAXIMAOPER"],);
                $this->qtdMaxParcelasFactory->deleteQtdMaximaParcelasOperador($dataParam);
            }
            $this->connection->commit();
        }catch(\Exception $e){
            $this->connection->rollback();
            throw $e;
        }
    }
}